---
slug: /en/sql-reference/functions/geo/
sidebar_label: Geo
sidebar_position: 62
title: "Geo Functions"
---


## Geographical Coordinates Functions

-   [greatCircleDistance](./coordinates.md#greatcircledistance)
-   [geoDistance](./coordinates.md#geodistance)
-   [greatCircleAngle](./coordinates.md#greatcircleangle)
-   [pointInEllipses](./coordinates.md#pointinellipses)
-   [pointInPolygon](./coordinates.md#pointinpolygon)

## Geohash Functions
-   [geohashEncode](./geohash.md#geohashencode)
-   [geohashDecode](./geohash.md#geohashdecode)
-   [geohashesInBox](./geohash.md#geohashesinbox)

## H3 Indexes Functions

-   [h3IsValid](./h3.md#h3isvalid)
-   [h3GetResolution](./h3.md#h3getresolution)
-   [h3EdgeAngle](./h3.md#h3edgeangle)
-   [h3EdgeLengthM](./h3.md#h3edgelengthm)
-   [h3EdgeLengthKm](./h3.md#h3edgelengthkm)
-   [geoToH3](./h3.md#geotoh3)
-   [h3ToGeo](./h3.md#h3togeo)
-   [h3ToGeoBoundary](./h3.md#h3togeoboundary)
-   [h3kRing](./h3.md#h3kring)
-   [h3GetBaseCell](./h3.md#h3getbasecell)
-   [h3HexAreaM2](./h3.md#h3hexaream2)
-   [h3HexAreaKm2](./h3.md#h3hexareakm2)
-   [h3IndexesAreNeighbors](./h3.md#h3indexesareneighbors)
-   [h3ToChildren](./h3.md#h3tochildren)
-   [h3ToParent](./h3.md#h3toparent)
-   [h3ToString](./h3.md#h3tostring)
-   [stringToH3](./h3.md#stringtoh3)
-   [h3GetResolution](./h3.md#h3getresolution)
-   [h3IsResClassIII](./h3.md#h3isresclassiii)
-   [h3IsPentagon](./h3.md#h3ispentagon)
-   [h3GetFaces](./h3.md#h3getfaces)
-   [h3CellAreaM2](./h3.md#h3cellaream2)
-   [h3CellAreaRads2](./h3.md#h3cellarearads2)
-   [h3ToCenterChild](./h3.md#h3tocenterchild)
-   [h3ExactEdgeLengthM](./h3.md#h3exactedgelengthm)
-   [h3ExactEdgeLengthKm](./h3.md#h3exactedgelengthkm)
-   [h3ExactEdgeLengthRads](./h3.md#h3exactedgelengthrads)
-   [h3NumHexagons](./h3.md#h3numhexagons)
-   [h3Line](./h3.md#h3line)
-   [h3Distance](./h3.md#h3distance)
-   [h3HexRing](./h3.md#h3hexring)
-   [h3GetUnidirectionalEdge](./h3.md#h3getunidirectionaledge)
-   [h3UnidirectionalEdgeIsValid](./h3.md#h3unidirectionaledgeisvalid)
-   [h3GetOriginIndexFromUnidirectionalEdge](./h3.md#h3getoriginindexfromunidirectionaledge)
-   [h3GetDestinationIndexFromUnidirectionalEdge](./h3.md#h3getdestinationindexfromunidirectionaledge)
-   [h3GetIndexesFromUnidirectionalEdge](./h3.md#h3getindexesfromunidirectionaledge)
-   [h3GetUnidirectionalEdgesFromHexagon](./h3.md#h3getunidirectionaledgesfromhexagon)
-   [h3GetUnidirectionalEdgeBoundary](./h3.md#h3getunidirectionaledgeboundary)

## S2 Index Functions

-   [geoToS2](./s2.md#geotos2)
-   [s2ToGeo](./s2.md#s2togeo)
-   [s2GetNeighbors](./s2.md#s2getneighbors)
-   [s2CellsIntersect](./s2.md#s2cellsintersect)
-   [s2CapContains](./s2.md#s2capcontains)
-   [s2CapUnion](./s2.md#s2capunion)
-   [s2RectAdd](./s2.md#s2rectadd)
-   [s2RectContains](./s2.md#s2rectcontains)
-   [s2RectUnion](./s2.md#s2rectunion)
-   [s2RectIntersection](./s2.md#s2rectintersection)


